#include <SoftwareSerial.h>


#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>


#define RED_LED    3
#define BLUE_LED   6
#define GREEN_LED  5

#define BOARD_LED  13

byte SerialIn;
bool _debug = false;
 
SoftwareSerial mySerialDbg(8, 9);
 
void setup() 
{                
  pinMode(RED_LED,   OUTPUT);     
  pinMode(BLUE_LED,  OUTPUT);     
  pinMode(GREEN_LED, OUTPUT);    
  pinMode(BOARD_LED, OUTPUT);   
  
  
  digitalWrite(GREEN_LED, HIGH); 
  digitalWrite(BLUE_LED, HIGH); 
  digitalWrite(RED_LED, HIGH); 
 
  
  Serial.begin(9600);  
  
  
  mySerialDbg.begin(9600);
  delay(500);
  mySerialDbg.println("Test Serial");
  
  //digitalWrite(RED_LED, HIGH);   // set the LED on
  //digitalWrite(BLUE_LED, HIGH);   // set the LED on
  //digitalWrite(GREEN_LED, HIGH);   // set the LED on
  
  //analogWrite(GREEN_LED, 50);
  
  
 
  // test bluetooth
  delay(1000);
  Serial.println("+++"); 
  delay(4000); 
  
  Serial.println("at+btsrv=1"); 
  delay(2000); 
  
  lampLed(2);
  
  digitalWrite(GREEN_LED, LOW); 
  digitalWrite(BLUE_LED, LOW); 
  digitalWrite(RED_LED, LOW); 
   
  // test ach ...ok
  /*
  String strReceived = "";
  while(SerialIn != 13)
  {
    if (Serial.available() > 0) 
    {
    
      SerialIn = Serial.read();
      char a = char(SerialIn);
     
     //mySerialDbg.print(a);
      Serial.print(a); 
      strReceived += a;
    }
}
  strReceived +="\n";
  Serial.println("exit"); 
  Serial.println("with "  + strReceived); 

  while(true); 
  */ 
}

void lampLed(int nLamp)
{
  for(int i=0;i<nLamp;i++)
  {
      digitalWrite(BOARD_LED, HIGH);
      delay(500);
  
      digitalWrite(BOARD_LED, LOW);
      delay(500);

  }
}

String getSerialLine()
{
 String strReceived = "";
 //while(SerialIn != 13)
 while(SerialIn != '\n')
  {
    if (Serial.available() > 0) 
    {
         SerialIn = Serial.read();
         char a = char(SerialIn);
         strReceived += a;
         if (_debug)
         {
           Serial.print(a);
         }
         
    }
  }
  
  SerialIn = 0;
  //strReceived +="r\n";
  return strReceived; 
 
}

char getComponentFromString(String serialStr)
{
  char color = serialStr.charAt(0);
  
  return color;  
}

int getColorFromString(String serialStr)
{
  String intStr = serialStr.substring(1,4);
   
  char* intChars = "000";
  intStr.toCharArray(intChars,4);
  
  int val = atoi(intChars);
  
  return val;
}

void loop()
{
  
   String strRec = getSerialLine();
   //String strRec = "ciao";

   digitalWrite(BOARD_LED, HIGH);
   
   Serial.println("Rec:" + strRec + "\n");
   
   char colComponent = getComponentFromString(strRec);
 
   int colValue = getColorFromString(strRec);
  
   if(colComponent == 'R')
   {
     analogWrite(RED_LED, colValue);
   }
   else if(colComponent == 'G')
   {
     analogWrite(GREEN_LED, colValue);
   }
   else if(colComponent == 'B')
   {
     analogWrite(BLUE_LED, colValue);
   }
   else
   {
    //  digitalWrite(GREEN_LED, LOW); 
    //  digitalWrite(BLUE_LED, LOW); 
    //  digitalWrite(RED_LED, LOW); 
   }
   
   
   
   
}
